<template>
  <main class="page-wrapper">
    <base-breadcrumbs v-once :titles="createCrumbs" />

    <div class="showroom-wrapper">
      <div class="container">
        <div class="grid">
          <div class="one">
            <div class="showroom-image">
              <div class="slider product-detail-img-nav position-relative">
                <div
                  v-for="{
                    image_thumbnail,
                    image,
                  } in product.showroom_detail_images"
                  :key="image_thumbnail"
                  class="product-detail-mini-img overflow-hidden"
                >
                  <img
                    class="img-fluid w-100"
                    :src="image_thumbnail"
                    :alt="product.title"
                    @click="sliderImage = image"
                  />
                </div>
              </div>
              <div class="slider product-detail-big-imgs position-relative">
                <div class="product-detail-big-img overflow-hidden">
                  <img :src="sliderImage" :alt="product.title" />
                </div>
              </div>
            </div>
            <div
              class="showroom-stats d-flex align-items-center justify-content-between"
            >
              <div class="showroom-rating">
                <base-rating
                  editable
                  :rating="reactions.star"
                  @change="(rate) => onRate(rate, product.id)"
                />
                <div v-show="product.average_star" class="rating">
                  <i class="icon-star_full"></i>{{ product.average_star }}
                </div>
              </div>
              <div class="showroom-comments align-items-center">
                <div class="comment-label">Комментарии</div>
                <div class="comment-count">
                  <i class="icon-comment"></i>
                  <span>{{ product.comments_number }}</span>
                </div>
              </div>
            </div>
          </div>
          <div class="two">
            <div class="showroom-title">
              <h2>{{ product.name }}</h2>
            </div>
            <product-categories v-once :categories-ids="product.categories" />
          </div>
          <div class="three">
            <div class="showroom-description">
              <p>{{ product.description.trim() }}</p>
            </div>
            <div class="showroom-favorite">
              <input
                id="product-like-button"
                v-model="reactions.like"
                type="checkbox"
                hidden
                @click.prevent="() => onSave(product.id)"
              />
              <label for="product-like-button">
                <i class="icon-like"></i>
                <span>Добавить в избранное</span>
              </label>
            </div>
          </div>
        </div>
      </div>
    </div>

    <div v-if="productList.count" class="container">
      <div class="content">
        <h3 class="mb-5">Product List</h3>
        <div class="row">
          <div class="col-12">
            <div class="showroom-product-list row">
              <div
                v-for="(item, idx) in productList.results"
                :key="idx"
                class="col-6 col-md-4 col-lg-3"
              >
                <product-card-mini v-bind="item" />
              </div>
            </div>

            <base-pagination :total-pages="productList.count_pages" />
          </div>
        </div>
      </div>
    </div>

    <div class="showroom-contacts-wrapper">
      <h3 class="container">Showroom contacts</h3>
      <div class="showroom-contacts">
        <client-only v-if="placemarks.length">
          <yandex-map
            :coords="placemarks[0].coords"
            :controls="['smallMapDefaultSet']"
            zoom="15"
            :show-all-markers="placemarks.length !== 1"
            class="contacts-map"
          >
            <ymap-marker
              v-for="(placemark, idx) in placemarks"
              :key="idx"
              :marker-id="idx"
              v-bind="placemark"
            ></ymap-marker>
          </yandex-map>
        </client-only>
        <div class="contacts-info">
          <div class="showroom-title">{{ product.name }}</div>
          <div class="showroom-description">
            <p>{{ product.description }}</p>
          </div>
          <div class="showroom-links">
            <ul class="list-unstyled mb-0">
              <li
                v-for="({ phone_number }, idx) in product.showroom_phone"
                :key="idx"
              >
                <a :href="`tel:${phone_number}`">{{ phone_number }}</a>
              </li>
            </ul>
          </div>
          <div class="showroom-social">
            <ul
              v-if="product.showroom_social.length"
              class="list-unstyled mb-0"
            >
              <li v-for="social in product.showroom_social" :key="social.link">
                <a :href="social.link" target="_blank">
                  <img
                    :src="social.social_icon"
                    :alt="social.social_name"
                    width="24"
                    height="24"
                  />
                </a>
              </li>
            </ul>
            <a :href="product.link" class="showroom-page">
              <span>Перейти на официальную страницу</span>
              <i class="icon-arrow_long"></i>
            </a>
          </div>
        </div>
      </div>
    </div>

    <div class="container showroom-related">
      <related-content :slides="product.showroom_children" />
    </div>

    <product-comments v-if="defer(3)" />
  </main>
</template>

<script>
import { TypesMap, TypesGlobal } from '@/constants/store.types'
import { reactions } from '@/mixins/product'
import { Defer } from '@/mixins/utils'
const ProductCategories = () => import('@/components/product/Categories.vue')
const ProductComments = () => import('@/components/product/Comments.vue')
const ProductCardMini = () => import('@/components/product/ProductCardMini.vue')

export default {
  name: 'ShowroomPage',
  components: {
    ProductCategories,
    ProductComments,
    ProductCardMini,
  },
  mixins: [reactions, Defer()],
  validate({ params }) {
    return Number(params.id)
  },
  async asyncData({ store, params, error }) {
    try {
      const [product, schema] = await Promise.all([
        store.dispatch('products/fetchProduct', params.id),
        store.dispatch('products/fetchSchema', params.id),
      ])
      store.commit(TypesGlobal.mutations.SET_TITLE, product.name)
      return {
        product,
        productList: [],
        schema,
        sliderImage: product.showroom_detail_images[0].image,
      }
    } catch (e) {
      error({
        statusCode: e?.response?.status || 500,
        message: e?.message || 'Request Error',
      })
    }
  },
  fetchOnServer: false,
  fetch() {
    this.$axios
      .$get(`/showrooms/${this.$route.params.id}/bestitems/`)
      .then((productList) => {
        this.productList = productList
      })
  },
  head() {
    return {
      title: this.product.name,
    }
  },
  jsonld() {
    return this.schema
  },
  computed: {
    /** @return {Placemark[]} */
    placemarks() {
      return this.$store.getters[TypesMap.getters.GET_PLACEMARKS]([
        this.product,
      ])
    },
    reactions() {
      const product = this.$store.state.products[this.product.id]
      return {
        star: product.user_star,
        like: product.saved_user,
      }
    },
  },
  methods: {
    createCrumbs(match) {
      if (match.params?.id) {
        return this.product.name
      }
      return ''
    },
  },
}
</script>

<style lang="less" src="@/assets/style/pages/showroom.less"></style>
